﻿Public Class Form1

    Private myColumnKeys As Collections.Generic.List(Of String)
    Private myRowNames As Collections.Generic.List(Of String)

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        NumCols.Value = 3
        NumRows.Value = 2
        updaterowcol()
        LayoutGrid()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        updaterowcol()
        LayoutGrid()
    End Sub

    Private Sub updaterowcol()
        myColumnKeys = New Collections.Generic.List(Of String)
        For i As Integer = 1 To NumCols.Value
            myColumnKeys.Add("X Val " & i)
        Next i

        myRowNames = New Collections.Generic.List(Of String)
        For i As Integer = 1 To NumRows.Value
            myRowNames.Add("Y Val " & i)
        Next i

    End Sub

    Private Sub LayoutGrid()
        grid.DisplayLayout.Bands(0).Columns.ClearUnbound()
        Dim drow As Infragistics.Win.UltraWinGrid.UltraGridRow
        Dim trow As Infragistics.Win.UltraWinGrid.UltraGridRow
        If grid.Rows.Count > 0 Then
            drow = grid.GetRow(Infragistics.Win.UltraWinGrid.ChildRow.Last)
            Do While drow IsNot Nothing
                trow = drow
                If drow.HasPrevSibling Then
                    drow = drow.GetSibling(Infragistics.Win.UltraWinGrid.SiblingRow.Previous)
                Else
                    drow = Nothing
                End If
                trow.Delete(False)
            Loop
        End If

        'create columns for each column key
        Dim col As Infragistics.Win.UltraWinGrid.UltraGridColumn
        For Each key As String In myColumnKeys
            col = grid.DisplayLayout.Bands(0).Columns.Add(key)
            col.DataType = GetType(System.Boolean)
            col.DefaultCellValue = False
            col.Style = Infragistics.Win.UltraWinGrid.ColumnStyle.CheckBox
            col.Group = grid.DisplayLayout.Bands(0).Groups("X Vals")
        Next key
        Dim row As Infragistics.Win.UltraWinGrid.UltraGridRow
        For Each name As String In myRowNames
            row = grid.DisplayLayout.Bands(0).AddNew()
            row.Cells("Y Vals").Value = name
        Next name
    End Sub

End Class
